//
//  TxCreatePoolCell.swift
//  Cosmostation
//
//  Created by yongjoo jung on 2021/07/04.
//  Copyright © 2021 wannabit. All rights reserved.
//

import UIKit

class TxCreatePoolCell: TxCell {
    
    @IBOutlet weak var txIcon: UIImageView!
    @IBOutlet weak var txSenderLabel: UILabel!
    @IBOutlet weak var txPoolParam1Label: UILabel!
    @IBOutlet weak var txPoolParam2Label: UILabel!
    @IBOutlet weak var txPoolAsset1AmountLabel: UILabel!
    @IBOutlet weak var txPoolAsset1DenomLabel: UILabel!
    @IBOutlet weak var txPoolAsset2AmountLabel: UILabel!
    @IBOutlet weak var txPoolAsset2DenomLabel: UILabel!
    @IBOutlet weak var txPoolFutureGovernaceLabel: UILabel!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        txPoolParam1Label.font = UIFontMetrics(forTextStyle: .caption1).scaledFont(for: Font_12_caption1)
        txPoolParam2Label.font = UIFontMetrics(forTextStyle: .caption1).scaledFont(for: Font_12_caption1)
        
        txPoolAsset1AmountLabel.font = UIFontMetrics(forTextStyle: .caption1).scaledFont(for: Font_12_caption1)
        txPoolAsset2AmountLabel.font = UIFontMetrics(forTextStyle: .caption1).scaledFont(for: Font_12_caption1)
    }
    
    override func onBindMsg(_ chainConfig: ChainConfig, _ response: Cosmos_Tx_V1beta1_GetTxResponse, _ position: Int) {
        txIcon.image = txIcon.image?.withRenderingMode(.alwaysTemplate)
        txIcon.tintColor = chainConfig.chainColor
        
        let msg = try! Osmosis_Gamm_Balancer_V1beta1_MsgCreateBalancerPool.init(serializedData: response.tx.body.messages[position].value)
        txSenderLabel.text = msg.sender
        txSenderLabel.adjustsFontSizeToFitWidth = true
        
        txPoolParam1Label.text = "swapFee : "  + NSDecimalNumber.init(string: msg.poolParams.swapFee).multiplying(byPowerOf10: -18).rounding(accordingToBehavior: WUtils.handler18).stringValue
        txPoolParam2Label.text = "exitFee : "  + NSDecimalNumber.init(string: msg.poolParams.exitFee).multiplying(byPowerOf10: -18).rounding(accordingToBehavior: WUtils.handler18).stringValue
        
        let coin0 = Coin.init(msg.poolAssets[0].token.denom, msg.poolAssets[0].token.amount)
        let coin1 = Coin.init(msg.poolAssets[1].token.denom, msg.poolAssets[1].token.amount)
        
        WDP.dpCoin(chainConfig, coin0, txPoolAsset1DenomLabel, txPoolAsset1AmountLabel)
        WDP.dpCoin(chainConfig, coin1, txPoolAsset2DenomLabel, txPoolAsset2AmountLabel)
        
        txPoolFutureGovernaceLabel.text = msg.futurePoolGovernor
        
    }
}
