//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: confio/twasm/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query provides defines the gRPC querier service
///
/// Usage: instantiate `Confio_Twasm_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Confio_Twasm_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Confio_Twasm_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func privilegedContracts(
    _ request: Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest, Confio_Twasm_V1beta1_QueryPrivilegedContractsResponse>

  func contractsByPrivilegeType(
    _ request: Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest, Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeResponse>
}

extension Confio_Twasm_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "confio.twasm.v1beta1.Query"
  }

  /// PrivilegedContracts returns all privileged contracts
  ///
  /// - Parameters:
  ///   - request: Request to send to PrivilegedContracts.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func privilegedContracts(
    _ request: Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest, Confio_Twasm_V1beta1_QueryPrivilegedContractsResponse> {
    return self.makeUnaryCall(
      path: "/confio.twasm.v1beta1.Query/PrivilegedContracts",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makePrivilegedContractsInterceptors() ?? []
    )
  }

  /// ContractsByPrivilegeType returns all contracts that have registered for the
  /// privilege type
  ///
  /// - Parameters:
  ///   - request: Request to send to ContractsByPrivilegeType.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func contractsByPrivilegeType(
    _ request: Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest, Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeResponse> {
    return self.makeUnaryCall(
      path: "/confio.twasm.v1beta1.Query/ContractsByPrivilegeType",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeContractsByPrivilegeTypeInterceptors() ?? []
    )
  }
}

internal protocol Confio_Twasm_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'privilegedContracts'.
  func makePrivilegedContractsInterceptors() -> [ClientInterceptor<Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest, Confio_Twasm_V1beta1_QueryPrivilegedContractsResponse>]

  /// - Returns: Interceptors to use when invoking 'contractsByPrivilegeType'.
  func makeContractsByPrivilegeTypeInterceptors() -> [ClientInterceptor<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest, Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeResponse>]
}

internal final class Confio_Twasm_V1beta1_QueryClient: Confio_Twasm_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Confio_Twasm_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the confio.twasm.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Confio_Twasm_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query provides defines the gRPC querier service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Confio_Twasm_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Confio_Twasm_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// PrivilegedContracts returns all privileged contracts
  func privilegedContracts(request: Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Twasm_V1beta1_QueryPrivilegedContractsResponse>

  /// ContractsByPrivilegeType returns all contracts that have registered for the
  /// privilege type
  func contractsByPrivilegeType(request: Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeResponse>
}

extension Confio_Twasm_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "confio.twasm.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "PrivilegedContracts":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Twasm_V1beta1_QueryPrivilegedContractsResponse>(),
        interceptors: self.interceptors?.makePrivilegedContractsInterceptors() ?? [],
        userFunction: self.privilegedContracts(request:context:)
      )

    case "ContractsByPrivilegeType":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest>(),
        responseSerializer: ProtobufSerializer<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeResponse>(),
        interceptors: self.interceptors?.makeContractsByPrivilegeTypeInterceptors() ?? [],
        userFunction: self.contractsByPrivilegeType(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Confio_Twasm_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'privilegedContracts'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makePrivilegedContractsInterceptors() -> [ServerInterceptor<Confio_Twasm_V1beta1_QueryPrivilegedContractsRequest, Confio_Twasm_V1beta1_QueryPrivilegedContractsResponse>]

  /// - Returns: Interceptors to use when handling 'contractsByPrivilegeType'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeContractsByPrivilegeTypeInterceptors() -> [ServerInterceptor<Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeRequest, Confio_Twasm_V1beta1_QueryContractsByPrivilegeTypeResponse>]
}
